/* This will create SREFLIB.RXF : a set of  SRE-http
functions to be loaded into MacroSpace.  Run this if
you modify the source code (the .SRF files).
*/




foo=rxfuncquery('rexxlibregister')
if foo=1 then do
 say ' loading REXXLIB '
 call rxfuncadd 'rexxlibregister','rexxlib', 'rexxlibregister'
 call rexxlibregister
end
/*--------------   Load REXX libraries ----- */
/* Load up advanced REXX functions */
call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs


names.0=0
say " Create sre-http macrospace procedure library. "
say " This requires that macrospace be cleared (which might effect"
say " other OS/2 programs)"
call charout,'  Enter 1 if you wish to proceed: '
parse pull gogo
if gogo<>1 then do
   say "Nothing done."
   exit
end
foo=macroclear()
if foo=0 then say "Warning: Problem clearing macrospace. "

call charout,'  Enter 1 for dynamic macrospace, 0 for static: '
pull do_dynamic


/* LOAD THE "STATIC" PROCEDURES */
say "Loading static procedures "
retc=amacro2('OPENREAD.SRF','SREF_OPEN_READ','Before')
retc=amacro2('REPSTRG.SRF','SREF_REPLACESTRG','Before')
retc=amacro2('SREFVALU.SRF','SREF_VALUE','Before')

retc=amacro2('SELMOD.SRF','SREF_MODIFY_SELORIGINAL','Before')
retc=amacro2('PRANGE0.SRF','SREF_PROCESS_RANGE0','Before')
retc=amacro2('DEFAULT.SRF','SREF_GET_DEFAULT','Before')
retc=amacro2('LOGFAIL.SRF','SREF_FAIL','Before')
retc=amacro2('NOFOUND.SRF','SREF_NOT_FOUND_LOCAL','Before')
retc=amacro2('SREFERR.SRF','SREF_ERROR','Before')


say "Creating stubs for dynamic procedures  "
retc=amacro('SREFVER.SRF','SREF_VERSION','Before')
retc=amacro('GRABFIL1.SRF','SREF_GRAB_FILE','Before')
retc=amacro('MEDIATYP.SRF','SREF_MEDIATYPE','Before')
retc=amacro('HOST.SRF','SREF_HOST','Before')
retc=amacro('LOOKUP.SRF','SREF_LOOKUP_COUNT','Before')
retc=amacro('EXTRACTB.SRF','SREF_EXTRACT_BLOCK','Before')
retc=amacro('INSERTB.SRF','SREF_INSERT_BLOCK','Before')
retc=amacro('MAKEB.SRF','SREF_MAKE_BLOCK','Before')
retc=amacro('FIX_URL.SRF','SREF_FIX_URL','Before')
retc=amacro('GET_URL.SRF','SREF_GET_URL','Before')
retc=amacro('GMTTIME.SRF','SREF_NEW_GMT','Before')
retc=amacro('SREF_GMT.SRF','SREF_GMT','Before')
retc=amacro('COUNTERX.SRF','SREF_COUNTER','Before')
retc=amacro('XBITMAP.SRF','SREF_XBITMAP','Before')
retc=amacro('CHKTYPE.SRF','SREF_CHECK_TYPE','Before')

retc=amacro('SREFQUE.SRF','SREF_QUEUE','Before')

retc=amacro('DMNLUNCH.SRF','SREF_DMN_LAUNCH','Before')
retc=amacro('DMNEXIST.SRF','SREF_DMN_EXIST','Before')
retc=amacro('DMNASK.SRF','SREF_DMN_ASK','Before')
retc=amacro('DMNREPLY.SRF','SREF_DMN_REPLY','Before')
retc=amacro('DMNWAIT.SRF','SREF_DMN_WAIT','Before')
retc=amacro('DMNVALUE.SRF','SREF_DMN_VALUE','Before')
retc=amacro('DMNKILL.SRF','SREF_DMN_KILL','Before')


retc=amacro('PACK64.SRF','SREF_PACK64','Before')
retc=amacro('MKPACK64.SRF','SREF_MKPACK64','Before')


retc=amacro('NOTDDIR.SRF','SREF_SEND_NON_DATADIR','Before')
retc=amacro('mapimag0.SRF','SREF_ISMAP_IMAGE','Before')
retc=amacro('fixurl.SRF','SREF_FIX_URL_EXT','Before')


retc=amacro('EXPIRE.SRF','SREF_EXPIRE_RESPONSE','Before')
retc=amacro('SPECIAL.SRF','SREF_SPECIAL_REQUEST','Before')
retc=amacro('RANGE.SRF','SREF_PROCESS_RANGE','Before')
retc=amacro('AUTOHEAD.SRF','SREF_DO_AUTO_HEADER','Before')
retc=amacro('DOPUT.SRF','SREF_DO_PUT','Before')
retc=amacro('GETREMOT.SRF','SREF_GET_REMOTE','Before')
retc=amacro('HOSTINFO.SRF','SREF_HOST_INFO','Before')
retc=amacro('BADIPS.SRF','SREF_BADIPS','Before')
retc=amacro('CGIVARS.SRF','SREF_CGIVARS','Before')
retc=amacro('GTCOOKIE.SRF','SREF_GET_COOKIE','Before')
retc=amacro('DOVIRT.SRF','SREF_DO_VIRTUAL','Before') 
retc=amacro('HTACCESS.SRF','SREF_HTACCESS','Before')
retc=amacro('DATEFMT.SRF','SREF_DATETIME_CONVERT','Before')
retc=amacro('NOTFOUND.SRF','SREF_NOT_FOUND_RESPONSE','Before')
retc=amacro('RESPONSE.SRF','SREF_RESPONSE','Before')
retc=amacro('PUBURLS.SRF','SREF_PUBLIC_URLS','Before')
retc=amacro('ISAMOVE.SRF','SREF_ISA_MOVE','Before')
retc=amacro('CLIENTNM.SRF','SREF_CLIENTNAME','Before')
retc=amacro('PMPRINTF.SRF','PMPRINTF_SREF','Before')
retc=amacro('negotiat.srf','SREF_DO_NEGOTIATE','before')
retc=amacro('ADDCOMMA.SRF','SREF_ADDCOMMA','Before')

retc=amacro('ADDPRIVS.SRF','SREF_ADD_PRIVS','Before')
RETC=AMACRO('GETPRIVS.SRF','SREF_GET_ADD_PRIVS','Before')
retc=amacro('SAVESTAT.SRF','SREF_SAVE_STATE','Before')
retc=amacro('READSTAT.SRF','SREF_READ_STATE','Before')
retc=amacro('WRTESTAT.SRF','SREF_WRITE_STATE','Before')
retc=amacro('HOMEDIR.SRF','SREF_HOME_DIR','Before')
retc=amacro('DIR.SRF','SREF_DIR','Before')
retc=amacro('AUTODESC.SRF','SREF_AUTO_DESCRIBE','Before')
retc=amacro('CHKBROWS.SRF','SREF_BROWSER_INFO','Before')
retc=amacro('MULTSEND.SRF','SREF_MULTI_SEND','Before')
retc=amacro('BACKSRVR.SRF','SREF_BACKUPSERVER','Before')

retc=amacro('SREDATA.SRF','SREF_FIND_INDEX','Before')
retc=amacro('CUSTPRC1.SRF','SREF_SETNAME_SEARCH','Before')
retc=amacro('CUSTPRC2.SRF','SREF_SETNAME_STATUS','Before')
retc=amacro('CUSTPRC3.SRF','SREF_SETNAME_VALUE','Before')


retc=amacro('INI_CNTR.SRF','SREF_INIT_COUNTER','Before')
retc=amacro('WILDCARD.SRF','SREF_WILDCARD','Before')
retc=amacro('WILDMTCH.SRF','SREF_WILD_MATCH','Before')

retc=amacro('JULDATE.SRF','SREF_JULDATE','Before')

retc=amacro('ADVOPTH.SRF','sref_adv_opts_header','Before')
retc=amacro('ADVOPTE.SRF','sref_adv_opts_exec','Before')
retc=amacro('ADVOPTM.SRF','sref_adv_opts_mimetype','Before')


retc=amacro('SRCHFIXD.srf','SREF_SEARCH_FIXED','Before')

retc=amacro('CONJUREF.srf','SREF_CONJUREF','Before')
retc=amacro('DOCGI.srf','SREF_DOCGI','Before')
retc=amacro('DOCGI2.srf','SREF_DOCGI_PIECES','Before')
retc=amacro('DOCGI3.srf','SREF_DOCGI_PIECES_2','Before')

retc=amacro('GETPOST.srf','SREF_GETPOST','Before')
retc=amacro('MAPIMAGE.srf','SREF_MAPIMAGE','Before')
retc=amacro('MAILIT.srf','SREF_MAILIT','Before')
retc=amacro('SSI.SRF','SREF_DO_SSI','Before')


/* now create procname list */

if do_dynamic=0 then do         /* static, we're done */
  say " saving static macrospace procedures to SREFPRC1.RXL"
  foo=macrosave('SREFPRC1.RXL')
  if foo<>1 then 
        say "Error creating SREFPRC1.RXL : " foo
  else
        say " success! "
  exit
end


yy=sysfiledelete('tempsref.cmd')
bigfile='tempsref.cmd'
call lineout bigfile, '/* SREF_PROCNAMES */'
call lineout bigfile,' parse arg nopt '
nams=' nams=" '
do mm=1 to names.0
   nams=nams' 'strip(translate(names.mm))
   if length(nams)>90 & mm<names.0 then do
        call lineout bigfile,nams'" ,'
       nams='" '
   end /* do */
end /* do */
if nams<>'" ' then call lineout bigfile,nams ' " '

call lineout bigfile,' '
fils=' fils=" '
do mm=1 to names.0
   fil1=translate(names.mm.!file)
   iuu=pos('.',fil1) ; fil1=delstr(fil1,iuu)  /* save space by strippihng .srf */
   fils=fils' 'strip(fil1)
   if length(fils)>90 & mm<names.0 then do
        call lineout bigfile,fils'" ,'
       fils='" '
   end /* do */
end /* do */
if fils<>'" ' then call lineout bigfile,fils ' " '
call lineout bigfile,' if nopt="" | nopt=1 then return nams ; return fils '

call lineout bigfile

foo=macroadd('SREF_PROCNAMES',bigfile,'b')
say " Adding SREF_PROCNAMES: " foo
/*yy=sysfiledelete('tempsref.cmd')*/

say "  Creating srefprc2.rxl file... "

ll:
foo=macrosave('SREFPRC2.RXL')
if foo<>1 then
  say " Problem saving SREFPRC2.RXL (error= " foo
else
  say "success!"
yy=sysfiledelete('tempsref.cmd')

exit

amacro:
parse arg filename,procname

if do_dynamic=0 then do         /* static */
   uu=amacro2(filename,procname,'before')
   return uu
end /* do */


inn=names.0+1
names.0=inn
names.inn=procname
names.inn.!file=filename


l.1='/* stub for: 'procname ' */'
l.2='parse arg a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,A14,A15,A16,A17,A18,A19,A20'
l.3='fdir=value("SRE_LIBDIR",,"os2environment")'
l.4='if fdir="" then do  '
l.5='   call pmprintf("ERROR:' procname ', could not find sre_libdir") ;exit '
l.6='end'
l.7='fn=strip(fdir,"t","\")"\'filename'"'
l.8='aa=macroadd("'procname'",'fn',"b")'
l.9='if aa=0 then do ; call pmprintf("ERROR: could not load " 'fn') ;exit ;end '
l.10='call pmprintf("Replacing stub of 'procname'")'
l.11='rrr='procname'(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,A14,A15,A16,A17,A18,A19,A20)'
l.12='return rrr '

yy=sysfiledelete('tempsref.cmd')
bigfile='tempsref.cmd'
do ii=1 to 12
  call lineout bigfile,l.ii
end
call lineout bigfile

foo=macroadd(procname,bigfile,'B')
say " using " filename ", adding " procname " stub = " foo


foo=stream(filename,'c','query exists')
if foo="" then do
   call charout, "WARNING: Could not find "filename " (Enter to continue..)"; parse pull 
end /* do */

return foo


amacro2:
parse arg v1,v2,v3
v3=left(v3,1)
foo=macroadd(v2,v1,v3)
if foo=0 then do
   say " Error creating: " v2 " from File=" v1 ' ( enter to continue '
   pull .
end /* do */
else
   say " Added " v1 " as " v2 
return foo




